<template>
  <div class="container-fluid mb-5 mt-5">
    <div class="row justify-content-center">
      <div class="col-md-4">
      
        <div class="card border-0 shadow rounded">
          <div class="card-body text-left">
            <h4 class="text-center font-weight-bold">Login</h4>
            <!-- form login -->
            <form @submit.prevent="login">
              <!-- email address -->
              <div class="form-group">
                <label>Email Address</label>
                <input type="email" v-model="user.email" class="form-control" />
              </div>
              <div v-if="validation.password" class="my-2" style="color: red;">
                <strong>{{ validation.email[0] }}</strong>
              </div>
              <div v-if="validation.message" class="my-2" style="color: red;">
                <strong>{{ validation.message }}</strong>
              </div>
              <!-- password -->
              <div class="form-group">
                <label>Password</label>
                <input type="password" v-model="user.password" class="form-control" />
              </div>
              <div v-if="validation.password" class="my-2" style="color: red;">
                <strong>{{ validation.password[0] }}</strong>
              </div>
              
              <!-- remember me -->
              <div class="form-group form-check">
                <input type="checkbox" class="form-check-input" id="exampleCheck1" />
                <label class="form-check-label" for="exampleCheck1">Remember Me</label>
              </div>

              <!-- button submit -->
              <button type="submit" class="btn btn-primary btn-block border-0">
                Login
              </button>
            </form>
          </div>
        </div>
        <!-- link to register -->
        <div class="register mt-3 text-center">
          <p>
            Don't have an account yet?
            <router-link :to="{ name: 'register' }">Register</router-link>
          </p>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { ref, reactive } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

export default {
  name: "LoginComponent",

  setup() {
    // use state
    const user = reactive({
      email: "",
      password: "",
    });

    // validation state
    const validation = ref([]);

    // store vuex
    const store = useStore();

    // route
    const router = useRouter();

    // method login
    function login()
    {
      // define variable
      let email = user.email;
      let password = user.password;

      // panggil action login dari module auth di vuex
      store.dispatch("auth/login", {
          email,
          password,
        })
        .then(() => {
          // redirect ke dashboard
          router.push({ name: "dashboard" });
        })
        .catch((error) => {
          // assign validation message
          validation.value = error;
        });
    }
    return {
      user,
      validation,
      login,
    }
  },
};
</script>
